> This page is for 平台, version V4 (default).
> For other versions, use one of these documentation indexes:
> - V4 (default): https://developer.frame.io/platform/v4/llms.txt
> - V4 实验版: https://developer.frame.io/platform/v4-experimental/llms.txt
> - 旧版: https://developer.frame.io/platform/v2/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developer.frame.io/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developer.frame.io/_mcp/server.

# 更新多个文件中的元数据

PATCH https://api.frame.io/v4/accounts/{account_id}/projects/{project_id}/metadata/values
Content-Type: application/json

Update metadata values across multiple files. Rate Limits: 10 calls per 1.00 minute(s) per account\_user

Reference: https://developer.frame.io/platform/api-reference/metadata/bulk-update

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `account_id` (string, required)
- `project_id` (string, required)

### Body (application/json)

This endpoint expects a BulkUpdateMetadataParams.

- `data` (BulkUpdateMetadataParamsData, required)

## Response

### 204

No Content

## Errors

### 400 Bad Request Error

Bad request

- `errors` (list of BadRequestErrorsItems, required)

### 401 Unauthorized Error

Unauthorized

- `errors` (list of UnauthorizedErrorsItems, required)

### 403 Forbidden Error

Forbidden

- `errors` (list of ForbiddenErrorsItems, required)

### 404 Not Found Error

Not found

- `errors` (list of NotFoundErrorsItems, required)

### 409 Conflict Error

Conflict

- `errors` (list of ConflictErrorsItems, required)

### 422 Unprocessable Entity Error

Unprocessable content

- `errors` (list of UnprocessableContentErrorsItems, required)

### 429 Too Many Requests Error

Too many requests

- `errors` (list of TooManyRequestsErrorsItems, required)

## Types

### BulkUpdateMetadataParamsData

- `file_ids` (list of string, required) — Files for bulk updates
- `values` (list of BulkUpdateMetadataParamsDataValuesItems, required) — Metadata field and value mapping params. Note: Select and MultiSelect field values should be passed as lists, eg: \[\<uuid>]. Users and MultiUser values should be passed as lists formatted as follows: \[\{id: \<user\_id>, type: "user"}, \{id: \<user\_group\_id>, type: "account\_user\_group"}

### BadRequestErrorsItems

- `detail` (string, required)
- `source` (BadRequestErrorsItemsSource, optional)
- `title` (string, optional)

### UnauthorizedErrorsItems

- `detail` (string, required)
- `source` (UnauthorizedErrorsItemsSource, optional)
- `title` (string, optional)

### ForbiddenErrorsItems

- `detail` (string, required)
- `source` (ForbiddenErrorsItemsSource, optional)
- `title` (string, optional)

### NotFoundErrorsItems

- `detail` (string, required)
- `source` (NotFoundErrorsItemsSource, optional)
- `title` (string, optional)

### ConflictErrorsItems

- `detail` (string, required)
- `source` (ConflictErrorsItemsSource, optional)
- `title` (string, optional)

### UnprocessableContentErrorsItems

- `detail` (string, required)
- `source` (UnprocessableContentErrorsItemsSource, optional)
- `title` (string, optional)

### TooManyRequestsErrorsItems

- `detail` (string, required)
- `source` (TooManyRequestsErrorsItemsSource, optional)
- `title` (string, optional)

### BulkUpdateMetadataParamsDataValuesItems

- `field_definition_id` (string, required)
- `value` (any, required)

### BadRequestErrorsItemsSource

- `pointer` (string, optional)

### UnauthorizedErrorsItemsSource

- `pointer` (string, optional)

### ForbiddenErrorsItemsSource

- `pointer` (string, optional)

### NotFoundErrorsItemsSource

- `pointer` (string, optional)

### ConflictErrorsItemsSource

- `pointer` (string, optional)

### UnprocessableContentErrorsItemsSource

- `pointer` (string, optional)

### TooManyRequestsErrorsItemsSource

- `pointer` (string, optional)

## Examples

**Request**

```json
{
  "data": {
    "file_ids": [
      "bd2aab4f-30f5-4e99-8382-7f1f9fbeae85",
      "c42fc3d3-199e-4218-8179-ac54d2ac5ead"
    ],
    "values": [
      {
        "field_definition_id": "2f815bf1-9710-4ad8-b406-970c7cea3052",
        "value": [
          {
            "id": "e3ed15ac-d705-47aa-b181-9f5a4291e9d7",
            "type": "user"
          },
          {
            "id": "13e3625d-5b54-4fa6-85c2-cd2f4cdeb26e",
            "type": "account_user_group"
          }
        ]
      }
    ]
  }
}
```

**SDK Code**

```python
import requests

url = "https://api.frame.io/v4/accounts/5bcda301-2dd8-43b2-8407-eaed54f7f74a/projects/2d741ccb-1c76-42dc-9da9-b89aef9c8d21/metadata/values"

payload = { "data": {
        "file_ids": ["bd2aab4f-30f5-4e99-8382-7f1f9fbeae85", "c42fc3d3-199e-4218-8179-ac54d2ac5ead"],
        "values": [
            {
                "field_definition_id": "2f815bf1-9710-4ad8-b406-970c7cea3052",
                "value": [
                    {
                        "id": "e3ed15ac-d705-47aa-b181-9f5a4291e9d7",
                        "type": "user"
                    },
                    {
                        "id": "13e3625d-5b54-4fa6-85c2-cd2f4cdeb26e",
                        "type": "account_user_group"
                    }
                ]
            }
        ]
    } }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.frame.io/v4/accounts/5bcda301-2dd8-43b2-8407-eaed54f7f74a/projects/2d741ccb-1c76-42dc-9da9-b89aef9c8d21/metadata/values';
const options = {
  method: 'PATCH',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"data":{"file_ids":["bd2aab4f-30f5-4e99-8382-7f1f9fbeae85","c42fc3d3-199e-4218-8179-ac54d2ac5ead"],"values":[{"field_definition_id":"2f815bf1-9710-4ad8-b406-970c7cea3052","value":[{"id":"e3ed15ac-d705-47aa-b181-9f5a4291e9d7","type":"user"},{"id":"13e3625d-5b54-4fa6-85c2-cd2f4cdeb26e","type":"account_user_group"}]}]}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.frame.io/v4/accounts/5bcda301-2dd8-43b2-8407-eaed54f7f74a/projects/2d741ccb-1c76-42dc-9da9-b89aef9c8d21/metadata/values"

	payload := strings.NewReader("{\n  \"data\": {\n    \"file_ids\": [\n      \"bd2aab4f-30f5-4e99-8382-7f1f9fbeae85\",\n      \"c42fc3d3-199e-4218-8179-ac54d2ac5ead\"\n    ],\n    \"values\": [\n      {\n        \"field_definition_id\": \"2f815bf1-9710-4ad8-b406-970c7cea3052\",\n        \"value\": [\n          {\n            \"id\": \"e3ed15ac-d705-47aa-b181-9f5a4291e9d7\",\n            \"type\": \"user\"\n          },\n          {\n            \"id\": \"13e3625d-5b54-4fa6-85c2-cd2f4cdeb26e\",\n            \"type\": \"account_user_group\"\n          }\n        ]\n      }\n    ]\n  }\n}")

	req, _ := http.NewRequest("PATCH", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.frame.io/v4/accounts/5bcda301-2dd8-43b2-8407-eaed54f7f74a/projects/2d741ccb-1c76-42dc-9da9-b89aef9c8d21/metadata/values")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"data\": {\n    \"file_ids\": [\n      \"bd2aab4f-30f5-4e99-8382-7f1f9fbeae85\",\n      \"c42fc3d3-199e-4218-8179-ac54d2ac5ead\"\n    ],\n    \"values\": [\n      {\n        \"field_definition_id\": \"2f815bf1-9710-4ad8-b406-970c7cea3052\",\n        \"value\": [\n          {\n            \"id\": \"e3ed15ac-d705-47aa-b181-9f5a4291e9d7\",\n            \"type\": \"user\"\n          },\n          {\n            \"id\": \"13e3625d-5b54-4fa6-85c2-cd2f4cdeb26e\",\n            \"type\": \"account_user_group\"\n          }\n        ]\n      }\n    ]\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.patch("https://api.frame.io/v4/accounts/5bcda301-2dd8-43b2-8407-eaed54f7f74a/projects/2d741ccb-1c76-42dc-9da9-b89aef9c8d21/metadata/values")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"data\": {\n    \"file_ids\": [\n      \"bd2aab4f-30f5-4e99-8382-7f1f9fbeae85\",\n      \"c42fc3d3-199e-4218-8179-ac54d2ac5ead\"\n    ],\n    \"values\": [\n      {\n        \"field_definition_id\": \"2f815bf1-9710-4ad8-b406-970c7cea3052\",\n        \"value\": [\n          {\n            \"id\": \"e3ed15ac-d705-47aa-b181-9f5a4291e9d7\",\n            \"type\": \"user\"\n          },\n          {\n            \"id\": \"13e3625d-5b54-4fa6-85c2-cd2f4cdeb26e\",\n            \"type\": \"account_user_group\"\n          }\n        ]\n      }\n    ]\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PATCH', 'https://api.frame.io/v4/accounts/5bcda301-2dd8-43b2-8407-eaed54f7f74a/projects/2d741ccb-1c76-42dc-9da9-b89aef9c8d21/metadata/values', [
  'body' => '{
  "data": {
    "file_ids": [
      "bd2aab4f-30f5-4e99-8382-7f1f9fbeae85",
      "c42fc3d3-199e-4218-8179-ac54d2ac5ead"
    ],
    "values": [
      {
        "field_definition_id": "2f815bf1-9710-4ad8-b406-970c7cea3052",
        "value": [
          {
            "id": "e3ed15ac-d705-47aa-b181-9f5a4291e9d7",
            "type": "user"
          },
          {
            "id": "13e3625d-5b54-4fa6-85c2-cd2f4cdeb26e",
            "type": "account_user_group"
          }
        ]
      }
    ]
  }
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.frame.io/v4/accounts/5bcda301-2dd8-43b2-8407-eaed54f7f74a/projects/2d741ccb-1c76-42dc-9da9-b89aef9c8d21/metadata/values");
var request = new RestRequest(Method.PATCH);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"data\": {\n    \"file_ids\": [\n      \"bd2aab4f-30f5-4e99-8382-7f1f9fbeae85\",\n      \"c42fc3d3-199e-4218-8179-ac54d2ac5ead\"\n    ],\n    \"values\": [\n      {\n        \"field_definition_id\": \"2f815bf1-9710-4ad8-b406-970c7cea3052\",\n        \"value\": [\n          {\n            \"id\": \"e3ed15ac-d705-47aa-b181-9f5a4291e9d7\",\n            \"type\": \"user\"\n          },\n          {\n            \"id\": \"13e3625d-5b54-4fa6-85c2-cd2f4cdeb26e\",\n            \"type\": \"account_user_group\"\n          }\n        ]\n      }\n    ]\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["data": [
    "file_ids": ["bd2aab4f-30f5-4e99-8382-7f1f9fbeae85", "c42fc3d3-199e-4218-8179-ac54d2ac5ead"],
    "values": [
      [
        "field_definition_id": "2f815bf1-9710-4ad8-b406-970c7cea3052",
        "value": [
          [
            "id": "e3ed15ac-d705-47aa-b181-9f5a4291e9d7",
            "type": "user"
          ],
          [
            "id": "13e3625d-5b54-4fa6-85c2-cd2f4cdeb26e",
            "type": "account_user_group"
          ]
        ]
      ]
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.frame.io/v4/accounts/5bcda301-2dd8-43b2-8407-eaed54f7f74a/projects/2d741ccb-1c76-42dc-9da9-b89aef9c8d21/metadata/values")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PATCH"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```